<?php
/**
* @version		$Id: plg_com_phocagallery.php,v 1.1 2008/04/24 20:31:51 pythontech Exp $
* @package		pt_smartsef_phocagallery
* @subpackage	Admin
* @copyright	Copyright 2008 Python Technology Ltd
* @license		GNU/GPL, see LICENSE.php
*
*/

#-----------------------------------------------------------------------
#	Convert non-SEF URLs produced by phocagallery
#-----------------------------------------------------------------------
function PhocagalleryBuildRoute($query)
{
  global $_ptsef_phocagallery;
  $db =& JFactory::getDBO();
  $qu = $query;

  if ($_ptsef_phocagallery == NULL) {
    $sql = "SELECT params FROM #__smartsef_plugins WHERE plugin='plg_com_phocagallery'" ;
    $db->setQuery($sql);
    $params = $db->loadResult();
    $jp = new JParameter($params);
    $_ptsef_phocagallery =
      array('prefix' => $jp->get('prefix','gallery'));
  }

  $segments = array();
  if ($_ptsef_phocagallery['prefix'] != '') {
    $segments[] = $_ptsef_phocagallery['prefix'];
  }

  $view = _ptsefpg_get($qu, 'view');
  if ($view == 'category') {
    $slug = _ptsefpg_get($qu, 'id');
    $name = _ptsefpg_alias($slug,'category');
    $segments[] = $name;

  } elseif ($view == 'phocagalleryd') {
    $catid = _ptsefpg_get($qu, 'catid');
    $slug = _ptsefpg_get($qu, 'id');
    $name = _ptsefpg_alias($slug,'picture');
    $tmpl = _ptsefpg_get($qu, 'tmpl');
    if ($tmpl == 'component') {
      $segments[] = $name;
      $dl = _ptsefpg_get($qu, 'phocadownload','0');
      if ($dl != '0') {
	$segments[] = 'download';
      }
      $sl = _ptsefpg_get($qu, 'phocaslideshow','0');
      if ($sl != '0') {
	$segments[] = 'slideshow';
      }
    } else {
      $segments[] = $tmpl;
    }

  } else {
    // Default for unknown views
    $segments[] = $view;
  }

  /*--- Append any other guff */
  _ptsefpg_get($qu,'option');
  _ptsefpg_get($qu,'Itemid');
  if (isset($qu)) {
    foreach ($qu as $param => $value) {
      $segments[] = $param.'-'.$value;
    }
  }

  return $segments;
}

// Given a 'slug' consisting of an id and optional alias,
// e.g. '12:crocodile' or '12:' or '12'
// return the alias (if present) or the prefix+id
// e.g. 'crocodile' or 'picture12'
function _ptsefpg_alias($slug,$prefix='')
{
  $idalias = explode(':',$slug);
  if (count($idalias) > 1 and $idalias[1] != "") {
    $name = $idalias[1];
  } else {
    $name = $prefix.$idalias[0];
  }
  return $name;
}

function _ptsefpg_get(&$arr,$key,$dflt='')
{
  if (array_key_exists($key,$arr)) {
    $value = $arr[$key];
    unset($arr[$key]);
  } else {
    $value = $dflt;
  }
  return $value;
}

	  
